--- dovecot-1.0-stable/src/master/master-settings.c.orig	Mon Jan 31 16:37:55 2005
+++ dovecot-1.0-stable/src/master/master-settings.c	Thu May 12 11:25:41 2005
@@ -194,6 +194,7 @@
 	DEF(SET_STR, location),
 	DEF(SET_BOOL, inbox),
 	DEF(SET_BOOL, hidden),
+	DEF(SET_BOOL, readonly),
 
 	{ 0, NULL, 0 }
 };
--- dovecot-1.0-stable/src/master/master-settings.h.orig	Mon Jan 31 16:37:55 2005
+++ dovecot-1.0-stable/src/master/master-settings.h	Thu May 12 11:26:58 2005
@@ -163,6 +163,7 @@
 
 	int inbox;
 	int hidden;
+	int readonly;
 };
 
 struct server_settings {
--- dovecot-1.0-stable/src/master/mail-process.c.orig	Tue Feb  8 10:30:11 2005
+++ dovecot-1.0-stable/src/master/mail-process.c	Thu May 12 11:26:37 2005
@@ -175,6 +175,8 @@
 			env_put(t_strdup_printf("NAMESPACE_%u_INBOX=1", i));
 		if (ns->hidden)
 			env_put(t_strdup_printf("NAMESPACE_%u_HIDDEN=1", i));
+		if (ns->readonly)
+			env_put(t_strdup_printf("NAMESPACE_%u_READONLY=1", i));
 		t_pop();
 	}
 }
--- dovecot-1.0-stable/src/imap/namespace.h.orig	Mon Jan 31 16:37:54 2005
+++ dovecot-1.0-stable/src/imap/namespace.h	Thu May 12 11:27:33 2005
@@ -16,7 +16,7 @@
 	char *prefix;
 	size_t prefix_len;
 
-	int inbox, hidden, subscriptions;
+	int inbox, hidden, readonly, subscriptions;
 	struct mail_storage *storage;
 };
 
--- dovecot-1.0-stable/src/imap/namespace.c.orig	Mon Jan 31 16:37:54 2005
+++ dovecot-1.0-stable/src/imap/namespace.c	Thu May 12 11:28:42 2005
@@ -31,7 +31,7 @@
 {
         struct namespace *ns;
         const char *sep, *type, *prefix;
-	int inbox, hidden, subscriptions;
+	int inbox, hidden, readonly, subscriptions;
 
 	ns = p_new(pool, struct namespace, 1);
 
@@ -40,6 +40,7 @@
 	prefix = getenv(t_strdup_printf("NAMESPACE_%u_PREFIX", num));
 	inbox = getenv(t_strdup_printf("NAMESPACE_%u_INBOX", num)) != NULL;
 	hidden = getenv(t_strdup_printf("NAMESPACE_%u_HIDDEN", num)) != NULL;
+	readonly = getenv(t_strdup_printf("NAMESPACE_%u_READONLY", num)) != NULL;
 	subscriptions = getenv(t_strdup_printf("NAMESPACE_%u_SUBSCRIPTIONS",
 					       num)) != NULL;
 
@@ -58,6 +59,7 @@
 	ns->prefix = p_strdup(pool, prefix);
 	ns->inbox = inbox;
 	ns->hidden = hidden;
+	ns->readonly = readonly;
 	ns->subscriptions = subscriptions;
 	ns->storage = mail_storage_create_with_data(data, user);
 	if (ns->storage == NULL) {
--- dovecot-1.0-stable/src/imap/cmd-select.c.orig	Tue Feb  8 11:30:29 2005
+++ dovecot-1.0-stable/src/imap/cmd-select.c	Thu May 19 15:33:21 2005
@@ -3,10 +3,12 @@
 #include "common.h"
 #include "commands.h"
 #include "imap-sync.h"
+#include "namespace.h"
 
 int _cmd_select_full(struct client *client, int readonly)
 {
 	struct mail_storage *storage;
+	struct namespace *ns;
 	struct mailbox *box;
 	struct mailbox_status status;
 	const char *mailbox;
@@ -24,11 +26,14 @@
 			client_send_untagged_storage_error(client, storage);
 	}
 
-	storage = client_find_storage(client, &mailbox);
-	if (storage == NULL)
+	ns = namespace_find(client->namespaces, &mailbox);
+	if (ns == NULL) {
+		client_send_tagline(client, "NO Unknown namespace.");
 		return TRUE;
+	}
+	storage = ns->storage;
 
-	box = mailbox_open(storage, mailbox, !readonly ? 0 :
+	box = mailbox_open(storage, mailbox, !(readonly | ns->readonly) ? 0 :
 			   (MAILBOX_OPEN_READONLY | MAILBOX_OPEN_KEEP_RECENT));
 	if (box == NULL) {
 		client_send_storage_error(client, storage);
